//
//  DiscoveryType.h
//  AliLiving
//
//  Created by Li Zheng on 2021/3/25.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface DiscoveryType : NSObject

// also can ref to IMSLocalDeviceType in
// Pods/IMSThingCapability/IMSThingCapability/IMSThingCapability.framework/Headers/IMSDiscoveryRegistry.h
typedef enum : NSInteger {
    DISCOVERY_LOCAL_ONLINE_DEVICE       = 0, // 本地在线设备，即当前和手机在同一局域网已配网在线的设备
    DISCOVERY_CLOUD_ENROLLEE_DEVICE     = 1, // 云端待配设备，一般是指零配或路由器配网方式发现并上报的待配网设备，从云端获取
    DISCOVERY_BLE_ENROLLEE_DEVICE       = 2, // 发现的是蓝牙 WiFi 双模设备（蓝牙模块广播的subType=2即为双模设备），需根据扫描到的蓝牙设备去云端获取该设备是蓝牙 WiFi 双模设备还是普通的蓝牙设备
    DISCOVERY_SOFT_AP_DEVICE            = 3, // 附近的 AP 热点，需要符合 adh_$PK_$mac 格式
    DISCOVERY_BEACON_DEVICE             = 4, // 一键配网发现的待配设备 adn$PK_$mac
    DISCOVERY_COMBO_SUBTYPE_0X03_DEVICE = 5, // 未配网的蓝牙 Combo 设备，表示未配置 Wi-Fi ，此时您需要绑定设备和配网设备
    DISCOVERY_COMBO_SUBTYPE_0X04_DEVICE = 6, // 已配网的蓝牙 Combo 设备，表示已配置 Wi-Fi ，此时您只需绑定设备即可
    DISCOVERY_APP_FOUND_BLE_MESH_DEVICE = 7,
    DISCOVERY_CLOUD_BLE_MESH_DEVICE     = 8,
} Discovery;

+ (NSInteger)getType:(NSString *)devType;
+ (NSString *)getValue:(NSInteger)type;

@end

NS_ASSUME_NONNULL_END
