//
//  IMSiLopOALanguageManguage.h
//  IMSOpenAccountCustom
//
//  Created by chuntao.wang1 on 2019/4/11.
//  Copyright © 2019年 chuntao.wang1. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface IMSiLopOALanguageManage : NSObject

+ (instancetype)shareInstance;

/**
 Language prefix:
    The language prefix determines which .lproj file to load，If you want to rewrite an SDK for your own language Settings, please refer to the setting of OA in the .m file
    语言前缀确定加载哪个.lproj文件,如果你想修改一个SDK为自己的语言设置,请参阅.m文件设置
 
 - Supported：Currently only eight languages are supported
 - Language list：German, English, Spanish, French, Japanese, Korean, Russian, Chinese
 - Language prefix：de、en、es、fr、ja、ko、ru、zh、hi、it
 - The default prefix：zh
 
 - 支持：目前只支持十种语言国际化
 - 语言列表：German, English, Spanish, French, Japanese, Korean, Russian, Chinese
 - 语言前缀：de、en、es、fr、ja、ko、ru、zh、hi、it
 - 默认语言：zh
 
 @param prefix Language prefix
 */
- (void)setOpenAccountModuleLanguageWithLanguagePrefix:(NSString *)prefix;

/**
 If you want to use your own bundle files, set the following methods
 如果你想使用自己的bundle文件，请设置以下方法
 
 @param bundleName bundle Name
 @param prefix  language prefix
 */
- (void)setOpenAccountModuleLanguageWithLanguagePrefix:(NSString *)prefix bundleName:(NSString *)bundleName;

/**
 Current language prefix：The default is zh

 @return Current language prefix
 */
- (NSString *)currentLanguagePrefix;

@end

NS_ASSUME_NONNULL_END
