require 'json'

package = JSON.parse(File.read(File.join(__dir__, 'package.json')))

Pod::Spec.new do |s|
  s.name         = 'react-native-ali-smartliving'
  s.version      = package['version']
  s.summary      = package['description']
  s.license      = package['license']

  s.authors      = package['author']
  s.homepage     = package['homepage']
  s.platform     = :ios, "9.0"

  s.source       = { :git => "https://github.com/flyskywhy/react-native-ali-smartliving.git", :tag => "v#{s.version}" }
  s.source_files  = "ios/**/*.{h,m}"
  s.resource_bundles = {"IMSOpenAccountCustomResource" => "ios/IMSOpenAccountCustom/IMSOpenAccountCustomResource.bundle/**/*.{lproj,json,xib}"}

  s.dependency 'React'

  # (必选) 基础包：提供了调用IoT官方服务的能力，是APP开发的必要SDK）
  # (必选) 用户帐号：支持2种账号体系：内置账号体系和自有账号体系
  s.dependency 'IMSApiClient', '1.6.7'
  s.dependency 'IMSAuthentication', '1.4.2'
  s.dependency 'IMSIotSmart', '1.2.2'
  s.dependency 'AlicloudSecurityGuardSDK', '5.4.165'
  s.dependency 'AlicloudSGSecurityBody', '5.4.94'
  s.dependency 'AlicloudSGMain', '5.4.165'
  s.dependency 'AlicloudALBBOpenAccount', '3.4.0.47'

  # (可选) 消息推送：提供了消息推送能力
  s.dependency 'AlicloudPushIoT', '1.9.5.5-noccp'
  s.dependency 'IMSPCloudPush', '1.0.2'
  s.dependency 'IMSPCloudNetwork', '1.0.0'

  # (可选) 设备控制：提供了设备状态感知及控制的能力
  s.dependency 'IMSThingCapability', '1.8.9'
  s.dependency 'IMSMobileChannel', '1.6.12'

  # (可选) 配网：包含了开发配网(WiFi、以太网、蜂窝网等)所需的SDK
  s.dependency 'IMSBoneKit', '1.3.11.2'
  # s.dependency 'AKReactNative', '0.59.9.2'
  s.dependency 'MJRefresh', '3.1.15'
  s.dependency 'ZipArchive', '1.4.0'
  # s.dependency 'IMSReactNativeExtension', '1.0.2'
  s.dependency 'IMSDeviceCenter', '1.12.7'
  # s.dependency 'CocoaAsyncSocket', '7.4.2'
  s.dependency 'Reachability', '3.2'

  # (可选) 蓝牙设备接入框架：提供了蓝牙设备接入需要的SDK
  s.dependency 'IMSBreezeSDK', '1.7.4'
  s.dependency 'IMSOtaBusinessSdk', '1.6.3'
  s.dependency 'IMSDeviceGateway', '1.6.8'
end
